/* Copyright (C) 2009 and 2010 Chris Vine

This program is distributed under the General Public Licence, version 2.
For particulars of this and relevant disclaimers see the file
COPYING distributed with the source files.

*/

#ifndef DIALOGS_H
#define DIALOGS_H

#include "prog_defs.h"

#include <gtk/gtk.h>

#include <c++-gtk-utils/window.h>

namespace InfoDialogCB {
  extern "C" void info_dialog_selected(GtkDialog*, int, void*);
}

class InfoDialog: public WinBase {
  // Objects of this class are not for copying
  InfoDialog(const InfoDialog&);
  InfoDialog& operator=(const InfoDialog&);
protected:
  virtual void on_delete_event(void);
public:
  friend void InfoDialogCB::info_dialog_selected(GtkDialog*, int, void*);

  // if the modal argument passed is false, then don't bother with a parent (pass 0)
  InfoDialog(const char* text, const char* caption,
	     GtkMessageType message_type, GtkWindow* parent_p, bool modal = true);
};

namespace PromptDialogCB {
  extern "C" void prompt_dialog_selected(GtkDialog*, int, void*);
}

class PromptDialog: public WinBase {
  bool result;

  // Objects of this class are not for copying
  PromptDialog(const PromptDialog&);
  PromptDialog& operator=(const PromptDialog&);
protected:
  virtual int get_exec_val(void) const;
  virtual void on_delete_event(void);
public:
  friend void PromptDialogCB::prompt_dialog_selected(GtkDialog*, int, void*);

  // if the modal argument passed is false, then don't bother with a parent (pass 0)
  PromptDialog(const char* text, const char* caption,
	       GtkWindow* parent_p, bool modal = true);
};

namespace AboutDialogCB {
  extern "C" void about_dialog_selected(GtkDialog*, int, void*);
}

class AboutDialog: public WinBase {
protected:
  virtual void on_delete_event(void);
public:
  friend void AboutDialogCB::about_dialog_selected(GtkDialog*, int, void*);

  // if the modal argument passed is false, then don't bother with a parent (pass the default of 0)
  AboutDialog(GtkWindow* parent_p = 0, bool modal = false);
};

#endif
