/* Copyright (C) 2009, 2010 and 2012 Chris Vine

This program is distributed under the General Public Licence, version 2.
For particulars of this and relevant disclaimers see the file
COPYING distributed with the source files.

*/

#ifndef PREFERENCES_H
#define PREFERENCES_H

#include "prog_defs.h"


#include <gtk/gtk.h>

#include <c++-gtk-utils/window.h>

namespace PreferencesCB {
  extern "C" void preferences_selected(GtkWidget*, void*);
}

class Preferences: public WinBase {
  GtkWidget* beep_button_p;
  GtkWidget* no_notify_button_p;
  GtkWidget* dialog_notify_button_p;
  GtkWidget* lib_notify_button_p;
  GtkWidget* tray_icon_button_p;
  GtkWidget* tooltip_button_p;
  GtkWidget* cancel_button_p;
  GtkWidget* ok_button_p;

  void get_prefs(void);
  void save_prefs(void) const;

  // Objects of this class are not for copying
  Preferences(const Preferences&);
  Preferences& operator=(const Preferences&);
public:
  friend void PreferencesCB::preferences_selected(GtkWidget*, void*);

  bool get_beep(void) const;
  Error::ReportMode get_error_mode(void) const;
  bool get_tray_icon(void) const;
  bool get_tooltip(void) const;

  Preferences(GtkWindow* parent_p);
};


#endif
